define(
"dojo/nls/sv/colors", ({
// local representation of all CSS3 named colors, companion to dojo.colors.  To be used where descriptive information
// is required for each color, such as a palette widget, and not for specifying color programatically.
	//Note: due to the SVG 1.0 spec additions, some of these are alternate spellings for the same color (e.g. gray / grey).
	//TODO: should we be using unique rgb values as keys instead and avoid these duplicates, or rely on the caller to do the reverse mapping?
	aliceblue: "aliceblå",
	antiquewhite: "antikvitt",
	aqua: "akvamarin",
	aquamarine: "akvamarin",
	azure: "azurblått",
	beige: "beige",
	bisque: "biskvi",
	black: "svart",
	blanchedalmond: "skållad mandel",
	blue: "blått",
	blueviolet: "blåviolett",
	brown: "brunt",
	burlywood: "träfärgat",
	cadetblue: "kadettblått",
	chartreuse: "chartreuse",
	chocolate: "choklad",
	coral: "korall",
	cornflowerblue: "kornblått",
	cornsilk: "gulvitt",
	crimson: "karmosinrött",
	cyan: "cyan",
	darkblue: "mörkblått",
	darkcyan: "mörkt cyan",
	darkgoldenrod: "mörkt gullris",
	darkgray: "mörkgrått",
	darkgreen: "mörkgrönt",
	darkgrey: "mörkgrått", // same as darkgray
	darkkhaki: "mörkt kaki",
	darkmagenta: "mörk magenta",
	darkolivegreen: "mörkt olivgrönt",
	darkorange: "mörkorange",
	darkorchid: "mörkt orkidé",
	darkred: "mörkrött",
	darksalmon: "mörkt laxfärgat",
	darkseagreen: "mörkt havsgrönt",
	darkslateblue: "mörkt skifferblått",
	darkslategray: "mörkt skiffergrått",
	darkslategrey: "mörkt skiffergrått", // same as darkslategray
	darkturquoise: "mörkturkost",
	darkviolet: "mörkviolett",
	deeppink: "djuprosa",
	deepskyblue: "mörkt himmelsblått",
	dimgray: "smutsgrått",
	dimgrey: "smutsgrått", // same as dimgray
	dodgerblue: "dodgerblått",
	firebrick: "tegelstensrött",
	floralwhite: "blomvitt",
	forestgreen: "skogsgrönt",
	fuchsia: "fuchsia",
	gainsboro: "gainsboro",
	ghostwhite: "spökvitt",
	gold: "guld",
	goldenrod: "gullris",
	gray: "grått",
	green: "grönt",
	greenyellow: "gröngult",
	grey: "grått", // same as gray
	honeydew: "honungsdagg",
	hotpink: "varmrosa",
	indianred: "indianrött",
	indigo: "indigo",
	ivory: "elfenbensvitt",
	khaki: "kaki",
	lavender: "lavendel",
	lavenderblush: "lavendelskimrande",
	lawngreen: "gräsmattegrönt",
	lemonchiffon: "citronchiffong",
	lightblue: "ljusblått",
	lightcoral: "ljuskorall",
	lightcyan: "ljust cyan",
	lightgoldenrodyellow: "ljust gullrisgult",
	lightgray: "ljusgrått",
	lightgreen: "ljusgrönt",
	lightgrey: "ljusgrått", // same as lightgray
	lightpink: "ljusrosa",
	lightsalmon: "ljust laxfärgat",
	lightseagreen: "ljust havsgrönt",
	lightskyblue: "ljust himmelsblått",
	lightslategray: "ljust skiffergrått",
	lightslategrey: "ljust skiffergrått", // same as lightslategray
	lightsteelblue: "ljust stålblått",
	lightyellow: "ljusgult",
	lime: "lime",
	limegreen: "limegrönt",
	linen: "linne",
	magenta: "magenta",
	maroon: "rödbrunt",
	mediumaquamarine: "mellanakvamarin",
	mediumblue: "mellanblått",
	mediumorchid: "mellanorkidé",
	mediumpurple: "mellanlila",
	mediumseagreen: "mellanhavsgrönt",
	mediumslateblue: "mellanskifferblått",
	mediumspringgreen: "mellanvårgrönt",
	mediumturquoise: "mellanturkost",
	mediumvioletred: "mellanviolettrött",
	midnightblue: "midnattsblått",
	mintcream: "mintgrädde",
	mistyrose: "dunkelrosa",
	moccasin: "mockasin",
	navajowhite: "navajovitt",
	navy: "marinblått",
	oldlace: "spetsvitt",
	olive: "olivfärgat",
	olivedrab: "olivsmutsgult",
	orange: "orange",
	orangered: "orangerött",
	orchid: "orkidé",
	palegoldenrod: "blekt gullris",
	palegreen: "blekgrönt",
	paleturquoise: "blekturkost",
	palevioletred: "blekviolettrött",
	papayawhip: "papayaröra",
	peachpuff: "persika",
	peru: "peru",
	pink: "rosa",
	plum: "plommon",
	powderblue: "pulverblått",
	purple: "lila",
	red: "rött",
	rosybrown: "rosenbrunt",
	royalblue: "kungligt blått",
	saddlebrown: "sadelbrunt",
	salmon: "laxfärgat",
	sandybrown: "sandbrunt",
	seagreen: "havsgrönt",
	seashell: "snäckskal",
	sienna: "sienna",
	silver: "silver",
	skyblue: "himmelsblått",
	slateblue: "skifferblått",
	slategray: "skiffergrått",
	slategrey: "skiffergrått", // same as slategray
	snow: "snö",
	springgreen: "vårgrönt",
	steelblue: "stålblått",
	tan: "mellanbrunt",
	teal: "blågrönt",
	thistle: "tistel",
	tomato: "tomatrött",
	transparent: "transparent",
	turquoise: "turkost",
	violet: "violett",
	wheat: "vete",
	white: "vitt",
	whitesmoke: "vit rök",
	yellow: "gult",
	yellowgreen: "gulgrönt"
})
);
